<template>
  <div class="search">
    <div class="form-field">
      <input
        v-model="query"
        placeholder="Wyszukaj filmy"
        type="text"
        @input="search"
        @keyup.enter="search"
      />
      <button @click="search"><i class="fas fa-search"></i></button>
    </div>
    <label for="cars">Sortowanie : </label>

    <select v-model="order" @change="changeOrder">
      <option
        class="option-select"
        v-for="el in orderList"
        :key="el.id"
        v-bind:value="{ id: el.id, text: el.text }"
      >
        {{ el.text }}
      </option>
    </select>
    <select v-model="sort" @change="changeOrder">
      <option
        class="option-select"
        v-for="el in sortList"
        :key="el.id"
        v-bind:value="{ id: el.id, text: el.text }"
      >
        {{ el.text }}
      </option>
    </select>
    <template v-if="data && data.total_pages > 0">
      <div v-if="data && data.total_pages > 0" class="center">
        <div class="pagination">
          <button
            :class="page < 2 ? 'disabled' : ''"
            @click="clickPreviousPage"
          >
            <i class="fas fa-angle-double-left"></i>
          </button>
          <button
            :class="page === data.total_pages ? 'disabled' : ''"
            @click="clickNextPage"
          >
            <i class="fas fa-angle-double-right"></i>
          </button>
        </div>
      </div>
      <div class="container">
        <Movie
          v-for="movie in data.results"
          :key="movie.id"
          :movie="movie"
        ></Movie>
      </div>

      <div class="pagination">
        <button :class="page < 2 ? 'disabled' : ''" @click="clickPreviousPage">
          <i class="fas fa-angle-double-left"></i>
        </button>
        <button
          :class="page === data.total_pages ? 'disabled' : ''"
          @click="clickNextPage"
        >
          <i class="fas fa-angle-double-right"></i>
        </button>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import MovieService from "@/service/movie/MovieService";
import Movie from "@/components/Movie.vue";
import MovieList from "@/model/movie/MovieList";

@Component({
  components: {
    Movie,
  },
})
export default class Search extends Vue {
  private query = "";
  private page = 1;
  private data: MovieList | null = null;
  private order = { id: "title", text: "Tytuł" };
  private sort = { id: "ASC", text: "Rosnąco" };

  private orderList = [
    { id: "title", text: "Tytuł" },
    { id: "popularity", text: "Popularność" },
  ];

  private sortList = [
    { id: "ASC", text: "Rosnąco" },
    { id: "DESC", text: "Malejąco" },
  ];

  changeOrder(): void {
    if (this.order.id === "title") {
      if (this.sort.id === "ASC") {
        this.data?.results.sort((a, b) =>
          a.title.toLowerCase() > b.title.toLowerCase() ? 1 : -1
        );
      } else {
        this.data?.results.sort((a, b) =>
          a.title.toLowerCase() < b.title.toLowerCase() ? 1 : -1
        );
      }
    }

    if (this.order.id === "popularity") {
      if (this.sort.id === "ASC") {
        this.data?.results.sort((a, b) =>
          a.popularity > b.popularity ? 1 : -1
        );
      } else {
        this.data?.results.sort((a, b) =>
          a.popularity < b.popularity ? 1 : -1
        );
      }
    }
  }

  async clickPage(page: number): Promise<void> {
    this.page = page;
    await this.search();
  }

  async clickPreviousPage(): Promise<void> {
    if (this.page > 1) {
      this.page = this.page - 1;
      await this.search();
    }
  }

  async clickNextPage() {
    if (this.data && this.page < this.data?.total_pages) {
      this.page = this.page + 1;
      await this.search();
    }
  }

  async search(): Promise<void> {
    if (this.query === "") {
      this.data = null;
    }

    console.log(this.query);
    this.data = await MovieService.getList(this.query, this.page);
    this.changeOrder();
  }
}
</script>

<style lang="scss" scoped>
$offWhite: #f8f0e3;
$primary: #11998e;
$secondary: #38ef7d;

.option-select {
  padding: 0.25rem;
  background-color: #2e2e2e;
  border: none;
  color: white;
}

select {
  padding: 0.25rem;
  background-color: #2e2e2e;
  border: none;
  color: white;
}
.container {
  display: flex;
  flex-direction: column;
  justify-content: center;
}

.form-field {
  margin: 1rem 0.5rem 1rem 0.5rem;
  display: flex;
  flex-direction: row;
  justify-content: center;
  border-bottom: 2px solid #2e2e2e;
  transition: border-color 0.2s;
  background: #2e2e2e;
}

.disabled {
  cursor: not-allowed;
  color: lightgray;
}

input {
  border-style: none;
  outline: none;
  background: transparent;
  padding: 0.5em;
  font-size: 1rem;
  color: $offWhite;
  width: 100%;
}

button {
  cursor: pointer;
  padding: 0;
  background: none;
  border: none;
  outline: none;
  background: transparent;
  padding: 0.5em;
  font-size: 1rem;
}

i {
  color: #858383;
}

i:hover {
  color: #a19d9d;
}

.form-field:focus-within {
  border-image: linear-gradient(to right, $primary, $secondary);
  border-image-slice: 1;
}

//pagination

.center {
  text-align: center;
}

.pagination {
  display: flex;
  flex-direction: row;
  justify-content: center;
}

.pagination button {
  color: black;
  padding: 8px 16px;
  text-decoration: none;
  transition: background-color 0.3s;
  margin: 0 4px;
}

@media (min-width: 576px) {
  .container {
    display: grid;
    grid-template-columns: 50% 50%;
    justify-content: center;
  }
}

@media (min-width: 992px) {
  .container {
    display: grid;
    grid-template-columns: 30% 30% 30%;
    justify-content: center;
  }
}

@media (min-width: 1200px) {
  .container {
    display: grid;
    grid-template-columns: 25% 25% 25% 25%;
    justify-content: center;
  }
}

@media (min-width: 1400px) {
  .container {
    display: grid;
    grid-template-columns: 20% 20% 20% 20% 20%;
    justify-content: center;
  }
}
</style>
